package com.jojubanking.boot.module.system.service.carousel;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.carousel.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.carousel.CarouselDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

/**
 * 轮播图 Service 接口
 *
 * @author admin
 */
public interface CarouselService {

    /**
     * 创建轮播图
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createCarousel(@Valid CarouselCreateReqVO createReqVO);

    /**
     * 更新轮播图
     *
     * @param updateReqVO 更新信息
     */
    void updateCarousel(@Valid CarouselUpdateReqVO updateReqVO);

    /**
     * 删除轮播图
     *
     * @param id 编号
     */
    void deleteCarousel(Integer id);

    /**
     * 获得轮播图
     *
     * @param id 编号
     * @return 轮播图
     */
    CarouselDO getCarousel(Integer id);

    /**
     * 获得轮播图列表
     *
     * @param ids 编号
     * @return 轮播图列表
     */
    List<CarouselDO> getCarouselList(Collection<Integer> ids);

    /**
     * 获得轮播图分页
     *
     * @param pageReqVO 分页查询
     * @return 轮播图分页
     */
    PageResult<CarouselDO> getCarouselPage(CarouselPageReqVO pageReqVO);

    /**
     * 获得轮播图列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 轮播图列表
     */
    List<CarouselDO> getCarouselList(CarouselExportReqVO exportReqVO);

}
